# BlackLizard 2008 - http://www.bytejuggler.com
# based on idea at: http://www.insanelygreattees.com/news/?p=51
# Use at your own risk

require "base64"

class DataUriMaker
	def initialize()
	end
	
	def process( base, path )
	
		puts "Searching " + path + " for files containing " + base + " in path"
		Dir.foreach( path + "/" ) { |file| processSingleFile( base, file, path ) }
	
	end
	
	def processSingleFile( base, source, path )
	
		if source.index(base) == nil
			return
		end

		if source.index(".html") != nil
			return
		end
	
		data = File.open( path + "/" + source, 'rb').read
	    out = Base64.encode64(data)
	    outFile = File.new( path + "/" + File.basename(source) + ".html", "w" )
	    
		ext = File.extname(source)
		ext = ext[1..source.length-1].downcase

	    content_type = case ext
			when "gif": "image/gif"
			when "jpg": "image/jpeg"
			when "jpeg": "image/jpeg"
			when "png": "image/png"
			when "pdf": "application/pdf"
			when "html", "htm", "shtml", "php": "text/html"
			when "txt": "text/plain"
			when "rtf": "application/rtf"
			when "doc": "application/msword"
			when "ppt": "application/vnd.ms-powerpoint"
			when "xls": "application/vnd.ms-excel"
			else "application/octet-stream"
		end	    	

	    outFile.puts "<html><head></head><body>"
	    outFile.puts "<a href=\"data:" + content_type + ";charset=utf-8;base64," + out + "\">Embedded : " + File.basename(source) + "</a>"
	    outFile.puts "</body></html>"
	    outFile.close
		puts "Processed " + source 
  	end
end

	if ARGV[0] == nil
		puts "Invalid source file base path"
		exit(0)
	end
	base = ARGV[0]
    targetDir = "."     # default if not specified
    targetDir = ARGV[1] if ARGV[1]!=nil

	maker = DataUriMaker.new()
	maker.process( base, targetDir )
	