# BlackLizard 2008 - http://www.bytejuggler.com
# Uses RubyCocoa : http://sourceforge.net/projects/rubycocoa
# Use at your own risk

require "osx/cocoa"
OSX.require_framework 'PDFKit'
include OSX

class PDFSplitter

def initialize()
end

def Split( sourceFile, dest, maxPagesPerFile )

	docN = 1
	srcDoc = PDFDocument.alloc.initWithURL(NSURL.fileURLWithPath(sourceFile))	
	pcount = srcDoc.pageCount
	baseFileName = File.basename(sourceFile)
	ext = File.extname(baseFileName)
	extPos = baseFileName.index(ext)
	baseFileName = baseFileName[0..extPos-1]	
	outdata = baseFileName + " has " + pcount.to_s + " pages"
	puts outdata
	while pcount > 0

		pdfDoc = PDFDocument.alloc.initWithURL(NSURL.fileURLWithPath("readme.pdf"))
		while pdfDoc.pageCount > 0
			pdfDoc.removePageAtIndex_(0)
		end
		
		pagesToGo = maxPagesPerFile
		if pcount < pagesToGo
			pagesToGo = pcount
		end
		
		pprocessed = 0
		while pagesToGo > 0
			page = srcDoc.pageAtIndex_(0)
			pdfDoc.insertPage_atIndex_(page, pprocessed)
			srcDoc.removePageAtIndex_(0)
			pcount -= 1
			pprocessed += 1
			pagesToGo -= 1
		end
		
		outdata = dest + "/" + baseFileName + "_" + docN.to_s + ".pdf"
		pdfDoc.writeToFile_( outdata )
		puts "Saved " + outdata + " with " + pprocessed.to_s + " pages"
		docN += 1
	end
	
end

end

if ARGV[0] == nil
	puts "Invalid source parameter"
	exit(1)
end
sourceFile = ARGV[0]

dest = "."
if ARGV[1] != nil
	dest = ARGV[1] 
end

maxPagesPerFile = 50
if ARGV[2] != nil
	maxPagesPerFile = ARGV[2] 
end

splitter = PDFSplitter.new()
splitter.Split( sourceFile, dest, maxPagesPerFile.to_i )
